/*
 * shm.c: caz de test pentru memorie partajata
 * IPC - SO - Laborator 5
 */

#include <sys/mman.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <stdio.h>
#include <string.h>
#include <unistd.h>
#include <sys/types.h>

int main(void)
{
	int fd, ret;
	char *addr;
	char wr[] = "Who's the White Rabbit?";
	char rd[] = "RD";

	fd = shm_open("/my_shm", O_CREAT | O_RDWR, 0644);
	if (fd < 0) {
		perror("shm_open");
		return -1;
	}

	ret = ftruncate(fd, 4096);
	if (ret < 0) {
		perror("ftruncate");
		return -1;
	}

	addr = mmap(NULL, 4096, PROT_READ | PROT_WRITE, MAP_SHARED, fd, 0);
	if (!addr) {
		perror("mmap");
		return -1;
	}
	memcpy(addr, wr, strlen(wr) + 1);
	memcpy(addr + 4096 - strlen(rd) - 1 , rd, strlen(rd) + 1);
	printf("Press any key to continue...\n");
	getchar();

	munmap(addr, 4096);
	close(fd);
	shm_unlink("/my_shm");

	return 0;
}
