/**
 * Definitii comune pentru sender si receiver
 * SO - Laborator 5 - IPC - ex 1
 */

#ifndef _COMMON_H
#define _COMMON_H

#define SEM_NAME "my_sems"
#define SIZE 30

#define CHECK(x) \
    do { \
        if (!(x)) { \
            printf("[%s]:%s:%d: ", __FILE__, \
            __FUNCTION__, __LINE__); \
            ErrorExit(#x); \
            ExitProcess(EXIT_FAILURE);\
        } \
    } while(0)

/*
 *    Error
 */
void ErrorExit(LPTSTR lpCond) {
    // Retrieve the system error message for the last-error code

    LPVOID lpMsgBuf;
    DWORD dw = GetLastError();

    FormatMessage(
        FORMAT_MESSAGE_ALLOCATE_BUFFER |
        FORMAT_MESSAGE_FROM_SYSTEM |
        FORMAT_MESSAGE_IGNORE_INSERTS,
        NULL,
        dw,
        MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT),
        (LPTSTR) &lpMsgBuf,
        0, NULL );

    // Display the error message and exit the process
    fprintf_s(stderr, "[%s]\n%s\n", lpCond, lpMsgBuf);
   
    LocalFree(lpMsgBuf);
}

#endif
