/**
 * Definitii comune pentru client si server
 * SO - Laborator 5 - IPC
 */

#ifndef _COMMON_H
#define _COMMON_H

#define SLOT_NAME "\\\\.\\mailslot\\sample_mailslot"
#define MSG_END "end"
#define MAX_SIZE    1024

#define CHECK(x) \
    do { \
        if (!(x)) { \
            printf("[%s]:%s:%d: ", __FILE__, \
            __FUNCTION__, __LINE__); \
            ErrorExit(#x); \
            ExitProcess(EXIT_FAILURE);\
        } \
    } while(0)

/*
 *    Error
 */
void ErrorExit(LPTSTR lpCond) {
    // Retrieve the system error message for the last-error code

    LPVOID lpMsgBuf;
    DWORD dw = GetLastError();

    FormatMessage(
        FORMAT_MESSAGE_ALLOCATE_BUFFER |
        FORMAT_MESSAGE_FROM_SYSTEM |
        FORMAT_MESSAGE_IGNORE_INSERTS,
        NULL,
        dw,
        MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT),
        (LPTSTR) &lpMsgBuf,
        0, NULL );

    // Display the error message and exit the process
    fprintf_s(stderr, "[%s]\n%s\n", lpCond, lpMsgBuf);
   
    LocalFree(lpMsgBuf);
}

#endif
